/*!
 * jQuery filterable Plugin
 * https://github.com/Reload-Lab/jquery-filterable
 *
 * @updated September 15, 2023
 * @version 1.0.0
 *
 * @author Domenico Gigante <domenico.gigante@reloadlab.it>
 * @copyright (c) 2023 Reload Laboratorio Multimediale <info@reloadlab.it> (https://www.reloadlab.it)
 * @license MIT
 */
!function(t){"use strict";jQuery.fn.filterableUtils={isNull:function(t){return null==t},notNull:function(t){return!this.isNull(t)}}}(),function(t){"use strict";var i=function(i,e){this.$cell=t(i),this.match=null,this.options=t.extend({},t.fn.filterableCell.defaults,e),this.init()};i.prototype={constructor:i,value:function(){return this.$cell.text()},setMatch:function(t){t?(this.$cell.addClass("filterable-match"),this.$cell.removeClass("filterable-mismatch")):(this.$cell.addClass("filterable-mismatch"),this.$cell.removeClass("filterable-match"))},isMatch:function(t){if("function"==typeof this.options.isMatch)this.match=this.options.isMatch(this.$cell,t);else{t="\\NULL"==t?"^\\s*$":".*"+(t=(t=t.replace(/[\-\[\]\/\{\}\(\)\+\?\.\\\^\$\|]/g,"\\$&")).replace(/\*/,".*"))+".*";var i=this.options.ignoreCase?"i":"",e=new RegExp(t,i);this.match=!0===e.test(this.value())}return this.setMatch(this.match),this.match},init:function(){this.$cell.addClass("filterable-cell"),t.proxy((function(){this.$cell.triggerHandler("init",this)}),this)},destroy:function(){this.$cell.removeClass("filterable-cell filterable-match filterable-mismatch"),this.$cell.removeData("fitlerableCell")}},t.fn.filterableCell=function(e){var o=arguments,l="filterableCell";return this.each((function(){var s=t(this),n=s.data(l),r="object"==typeof e&&e;n||"object"!=typeof r||s.data(l,n=new i(this,r)),"string"==typeof e&&n[e].apply(n,Array.prototype.slice.call(o,1))}))},t.fn.filterableCell.defaults={isMatch:null}}(jQuery),function(t){"use strict";var i=function(i,e){this.$row=t(i),this.cells=[],this.options=t.extend({},t.fn.filterableRow.defaults,e),this.init()};i.prototype={constructor:i,cell:function(t){return this.cells[t]},setMatch:function(t){t?(this.$row.addClass("filterable-match"),this.$row.removeClass("filterable-mismatch")):(this.$row.addClass("filterable-mismatch"),this.$row.removeClass("filterable-match"))},hasMismatch:function(){var i=!1;return t.each(this.cells,t.proxy((function(e,o){t.fn.filterableUtils.notNull(o)&&!1===o.match&&(i=!0)}),this)),i},filter:function(t,i){this.cells[i].isMatch(t),this.setMatch(!this.hasMismatch())},ignoredColumn:function(i){return t.fn.filterableUtils.notNull(this.options.onlyColumns)?-1===t.inArray(i,this.options.onlyColumns):-1!==t.inArray(i,this.options.ignoreColumns)},init:function(){this.$row.addClass("filterable-row"),this.$row.children("td").each(t.proxy((function(i,e){this.ignoredColumn(i)?this.cells.push(null):(t(e).filterableCell(this.options),this.cells.push(t(e).data("filterableCell")))}),this)),t.proxy((function(){this.$row.triggerHandler("init",this)}),this)},destroy:function(){this.$row.removeClass("filterable-row filterable-match filterable-mismatch"),this.$row.removeData("fitlerableRow")}},t.fn.filterableRow=function(e){var o=arguments,l="filterableRow";return this.each((function(){var s=t(this),n=s.data(l),r="object"==typeof e&&e;n||"object"!=typeof r||s.data(l,n=new i(this,r)),"string"==typeof e&&n[e].apply(n,Array.prototype.slice.call(o,1))}))},t.fn.filterableRow.defaults={}}(jQuery),function(t){"use strict";var i=function(i,e){this.$table=t(i),this.rows=null,this.popovers=null,this.queries={},this.options=t.extend({},t.fn.filterable.defaults,e),this.init()};i.prototype={constructor:i,ignoredColumn:function(i){return t.fn.filterableUtils.notNull(this.options.onlyColumns)?-1===t.inArray(i,this.options.onlyColumns):-1!==t.inArray(i,this.options.ignoreColumns)},filterHash:function(t){var i=this.$table.attr("id");return""!=i?"filter_"+i+"_"+t:"filter__"+t},initRows:function(){this.rows=[],this.$table.children("tbody,*").children("tr").each(t.proxy((function(i,e){0!==i&&(t(e).filterableRow(this.options),this.rows.push(t(e).data("filterableRow")))}),this))},autocompleteValues:function(i){var e={};return t.fn.filterableUtils.isNull(this.rows)&&this.initRows(),t.each(this.rows,t.proxy((function(t,o){o.hasMismatch()||(e[o.cell(i).value()]="")}),this)),t.map(e,(function(t,i){return i}))},filter:function(i,e){"function"==typeof this.options.beforeFilter&&this.options.beforeFilter(this.$table,e,i),t.fn.filterableUtils.isNull(this.rows)&&this.initRows(),t.each(this.rows,t.proxy((function(t,o){o.filter(i,e)}),this)),this.queries[e]=i,"function"==typeof this.options.afterFilter&&this.options.afterFilter(this.$table,e,i)},onFilter:function(i,e,o){var l={};""===e?(t.bbq.removeState(this.filterHash(o)),t(i).removeClass("filterable-active")):(l[this.filterHash(o)]=e,t.bbq.pushState(l),t(i).addClass("filterable-active")),t(i).popover("hide"),this.popovers[o].input(e),this.filter(e,o)},closePopovers:function(i){t('[data-toggle="popover"]').each((function(){t(this).is(i.target)||0!==t(this).has(i.target).length||0!==t(".popover").has(i.target).length||t(this).popover("hide")}))},hashChange:function(i,e){var o=this.filterHash(e),l=t.bbq.getState(o)||"";i.input(l),""!==l?i.$toggler.addClass("filterable-active"):i.$toggler.removeClass("filterable-active"),void 0!==this.queries[e]&&l!=this.queries[e]&&this.filter(l,e)},init:function(){this.$table.addClass("filterable"),this.popovers=[],this.$table.find("tr:first").first().children("td,th").each(t.proxy((function(i,e){var o=t(e);o.data("ftIgnore")&&-1===t.inArray(i,this.options.ignoreColumns)&&this.options.ignoreColumns.push(i),o.data("ftFilter")&&(t.fn.filterableUtils.isNull(this.options.onlyColumns)&&(this.options.onlyColumns=[]),-1===t.inArray(i,this.options.onlyColumns)&&this.options.onlyColumns.push(i))}),this)),this.$table.find("tr:first").first().children("td,th").each(t.proxy((function(i,e){if(this.ignoredColumn(i))this.popovers.push(null);else{var o;t.fn.filterableUtils.notNull(this.options.popoverSelector)?o=t(e).find(this.options.popoverSelector):(o=t(e).wrapInner("<div />").children().first(),t(o).data(t(e).data())),"function"==typeof this.options.onFilter?this.options.onFilter=t.proxy(this.options.onFilter,this):this.options.onFilter=t.proxy(this.onFilter,this),t(o).attr("data-toggle","popover").filterablePopover(this.options),this.popovers.push(t(o).data("filterablePopover")),this.popovers[i].index(i),t(o).on("show.bs.popover",t.proxy((function(){this.popovers[i].lookup(this.autocompleteValues(i))}),this));var l=this.filterHash(i),s=t.bbq.getState(l)||"";""!==s&&(this.popovers[i].input(s),t(o).addClass("filterable-active"),this.filter(s,i))}}),this)),t("body").on("click.filterable",t.proxy((function(t){this.closePopovers(t)}),this)),t(window).bind("hashchange.filterable",t.proxy((function(i){t.each(this.popovers,t.proxy((function(i,e){t.fn.filterableUtils.notNull(e)&&this.hashChange(e,i)}),this))}),this)),t.proxy((function(){this.$table.triggerHandler("init",this)}),this)},destroy:function(){this.$table.removeClass("filterable"),this.$table.removeData("filterable")}},t.fn.filterable=function(e){var o=arguments,l="filterable";return this.each((function(){var s=t(this),n=(s.attr("id"),s.data(l)),r="object"==typeof e&&e;n||"object"!=typeof r||s.data(l,n=new i(this,r)),"string"==typeof e&&n[e].apply(n,Array.prototype.slice.call(o,1))}))},t.fn.filterable.defaults={ignoreColumns:[],onlyColumns:null,ignoreCase:!0,popoverSelector:null,beforeFilter:null,afterFilter:null}}(jQuery),function(t){"use strict";var i=function(i,e){this.$toggler=t(i),this.colIndex,this.value,this.options=t.extend({},t.fn.filterablePopover.defaults,e),this.init()};i.prototype={constructor:i,index:function(i){if(t.fn.filterableUtils.isNull(i))return this.colIndex;this.colIndex=i},input:function(i){if(t.fn.filterableUtils.isNull(i))return this.$body.find(".filter-input");this.value=i},lookup:function(t){this.$body.find(".filter-input").filterableAutocomplete("lookup",t)},init:function(){this.$toggler.addClass("filterable-popover");var i=this.options.tplPopover,e=this.options.bodyPopover;this.$body=t(e),this.$body.find(".empty-input").on("click",t.proxy((function(t){t.preventDefault(),this.$body.find(".filter-input").val(""),this.$body.find(".filter-btn").trigger("click.filterable")}),this)),this.$body.find(".filter-btn").on("click.filterable",t.proxy((function(t){t.preventDefault(),"function"==typeof this.options.onFilter&&this.options.onFilter(this.$toggler,this.$body.find(".filter-input").val(),this.colIndex)}),this)),t(document).on("click.filterable",".popover-header .close-popover",(function(i){i.preventDefault(),t(this).parents(".popover").popover("hide")})),this.$body.find(".filter-input").filterableAutocomplete(this.options);var o=void 0!==this.$toggler.data("ftTitle")?this.$toggler.data("ftTitle"):this.$toggler.text();o&&(this.options.titleTpl&&(o=this.options.titleTpl.replace("%field%",o)),o+='<span class="fa fa-times ml-auto close-popover" role="button"></span>'),this.$toggler.popover(t.extend({container:"body",title:o,content:this.$body,sanitize:!1,html:!0,template:i,placement:"top",customClass:"filterable-popover"},this.options.popoverOptions)),this.$toggler.on("shown.bs.popover",t.proxy((function(){this.$body.find(".filter-input").val(this.value).focus()}),this)),this.$toggler.on("show.bs.popover",t.proxy((function(){this.$toggler.addClass("filterable-popover-click")}),this)),this.$toggler.on("hide.bs.popover",t.proxy((function(){this.$toggler.removeClass("filterable-popover-click")}),this)),t.proxy((function(){this.$toggler.triggerHandler("init",this)}),this)},destroy:function(){this.$toggler.removeClass("filterable-popover filterable-popover-click"),this.$toggler.removeData("filterablePopover")}},t.fn.filterablePopover=function(e){var o=arguments,l="filterablePopover";return this.each((function(){var s=t(this),n=s.data(l),r="object"==typeof e&&e;n||"object"!=typeof r||s.data(l,n=new i(this,r)),"string"==typeof e&&n[e].apply(n,Array.prototype.slice.call(o,1))}))},t.fn.filterablePopover.defaults={onFilter:null,tplPopover:'<div class="popover" role="tooltip"><div class="arrow"></div><h3 class="popover-header d-flex align-items-center"></h3><div class="popover-body"></div></div>',bodyPopover:'<form><div class="input-group"><input type="search" class="form-control form-control-sm filter-input"><div class="input-group-append"><button class="btn btn-primary btn-sm filter-btn"><span class="fa fa-check"></span></button><button class="btn btn-danger btn-sm empty-input"><span class="fa fa-times"></span></button></div><div class="position-relative flex-fill w-100 autocomplete-container"></div></div></form>',titleTpl:null,popoverOptions:null}}(jQuery),function(t){"use strict";var i=function(i,e){this.$input=t(i),this.options=t.extend({},t.fn.filterableAutocomplete.defaults,e),this.init()};i.prototype={constructor:i,lookup:function(t){this.$input.autocomplete("setOptions",{lookup:t})},init:function(){this.$input.addClass("filterable-autocomplete"),this.$input.autocomplete(t.extend({lookup:[],appendTo:this.$input.siblings(".autocomplete-container")},this.options.autocompleteOptions)),t.proxy((function(){this.$input.triggerHandler("init",this)}),this)},destroy:function(){this.$input.removeClass("filterable-autocomplete"),this.$input.removeData("filterableAutocomplete")}},t.fn.filterableAutocomplete=function(e){var o=arguments,l="filterableAutocomplete";return this.each((function(){var s=t(this),n=s.data(l),r="object"==typeof e&&e;n||"object"!=typeof r||s.data(l,n=new i(this,r)),"string"==typeof e&&n[e].apply(n,Array.prototype.slice.call(o,1))}))},t.fn.filterableAutocomplete.defaults={autocompleteOptions:{}}}(jQuery);